/*
 * double_chained_functions.h
 *
 *  Created on: 14.11.2017
 *      Author: lukas
 */

#ifndef DOUBLE_CHAINED_FUNCTIONS_H_
#define DOUBLE_CHAINED_FUNCTIONS_H_

typedef struct mydata
{
  char sensorname[10];
  float messwert;
} mydata;

typedef struct messdaten
{
  struct messdaten * next;
  struct messdaten * prev;
  struct mydata data;
} messdaten;

/* functon to insert the first element
 * in: firstelem; newelement
 * out: newelement
 * changed: firstelem
 */
messdaten* insertFirst (messdaten* firstelem, messdaten* newelement);

/* functon to insert the last element
 * in: firstelem; newelement
 * out: newelement
 * changed: lastelement
 */
messdaten* insertLast (messdaten* firstelem, messdaten* newelement);

/* functon to insert the element on a specific position
 * in: firstelem; newelement; position
 * out: newelement
 * changed: one more item in chained list...
 */
messdaten* insertPos (messdaten* firstelem, messdaten* newelement, int pos);

/* functon to delete the first element
 * in: firstelem;
 * out: newelement
 * changed: firstelem
 */
messdaten*
deleteFirst (messdaten* firstelem);

/* functon to delete the last element
 * in: firstelem
 * out: newelement
 * changed: lastelement
 */
messdaten* deleteLast (messdaten* firstelem);

/* functon to delete the element of a specific element
 * in: firstelem; newelement
 * out: newelement
 * changed: firstelem
 */
messdaten* deletePos (messdaten* firstelem, int pos);

/* functon to delete all the list elements
 * in: firstelem
 * out: newelement
 * changed: the whole list
 */
messdaten* deleteAll (messdaten* firstelem);

#endif /* DOUBLE_CHAINED_FUNCTIONS_H_ */
